#pragma once

//------------------------------------------------------------
// to_bool
//------------------------------------------------------------

template<typename T>
  inline bool to_bool( T t ) { return t != 0; }

//------------------------------------------------------------
// current_module
//------------------------------------------------------------

inline HINSTANCE current_module()
  { return ::GetModuleHandle(NULL); }

//------------------------------------------------------------
// msg
//------------------------------------------------------------

inline void msgbox( const char* str )
  { ::MessageBox( NULL, str, NULL, MB_OK|MB_ICONINFORMATION ); }

//------------------------------------------------------------
// resource
//------------------------------------------------------------

inline string load_string( UINT id )
{
	vector<char> buf( 1024 );
	while( "buffer is too small" )
	{
		size_t siz = ::LoadString( current_module(), id, &buf[0], buf.size() );
		if( siz < buf.size() )
		{
			buf.resize(siz);
			break;
		}
	}
	return string( buf.begin(), buf.end() );
}

inline HICON load_icon( UINT id )
{
	return ::LoadIcon( current_module(), MAKEINTRESOURCE(id) );
}

inline HMENU load_menu( UINT id )
{
	return ::LoadMenu( current_module(), MAKEINTRESOURCE(id) );
}

//-----------------------------------------------------------------------
// console_ostream
//-----------------------------------------------------------------------

class console_ostream
	: public ostream
{
	class console_ostreambuf
		: public std::basic_streambuf<char>
	{
		typedef std::char_traits<char> traits;
		virtual int_type overflow( int_type c = traits::eof() )
		{
			if( !traits::eq_int_type(c, traits::eof()) )
			{
				char ch = c;
				write(&ch, 1);
			}
			return c;
		}
		virtual std::streamsize xsputn( const char* s, std::streamsize n )
		{
			write(s, n);
			return n;
		}
		void write( const char* s, std::streamsize n )
		{
			DWORD written;
			::WriteFile( ::GetStdHandle(STD_OUTPUT_HANDLE), s, n, &written, NULL );
		}
	public:
		 console_ostreambuf() { ::AllocConsole(); }
		~console_ostreambuf() { ::FreeConsole(); }
	};

public:
	console_ostream() : ostream( new console_ostreambuf ) {}
};

