#pragma once
#include "MathUtil.h"

//-----------------------------------------------------------------------
// n
//-----------------------------------------------------------------------

const char* enrollUramadoClass();
HWND GenerateUraWnd( HWND wnd );

//-----------------------------------------------------------------------
// ܂Ȃ
//-----------------------------------------------------------------------

class FoldedRect
{
private:
	dcomp V[5]; // `̒_
	bool folded;

public:
	FoldedRect() {}
	FoldedRect( const RECT& pos )
	{
		V[0] = dcomp(pos.left, pos.top);
		V[1] = dcomp(pos.right, pos.top);
		V[2] = dcomp(pos.right, pos.bottom);
		V[3] = dcomp(pos.left, pos.bottom);
		V[4] = V[0];
		folded = false;
	}

	// p  d ɂ̂т钼BE܂č̏ɎĂC[W
	dcomp pf, df;
	bool isInside( const dcomp& p )
	{
		return arg( (p-pf) / df ) >= 0;
	}

	int isNearEdge( const dcomp& p );
	void foldBegin( const dcomp& p );
	bool foldContinue( const dcomp& p, const dcomp& q );
	void foldClear();
	bool is_folded() const { return folded; }
	double current_shape( vector<dcomp>& base, vector<dcomp>& uras );
	double current_shape( vector<POINT>& base, vector<POINT>& uras )
	{
		// doubleWXN[W֕ϊ
		vector<dcomp> base_d, uras_d;
		const double perc = current_shape( base_d, uras_d );

		base.resize( base_d.size() );
		for(int i=0; i!=base.size(); ++i)
		{
			base[i].x = long(base_d[i].real() - V[0].real());
			base[i].y = long(base_d[i].imag() - V[0].imag());
		}

		uras.resize( uras_d.size() );
		for(int i=0; i!=uras.size(); ++i)
		{
			uras[i].x = long(uras_d[i].real());
			uras[i].y = long(uras_d[i].imag());
		}

		return perc;
	}
	void current_inner_ura_poly( vector<POINT>& pts );

	bool get_orime( dcomp& p1, dcomp& p2 );
	bool rebend( const dcomp& p1, const dcomp& p2 );

	bool covers( const dcomp& pt );
	bool rect_covers( const dcomp& p );
};

//-----------------------------------------------------------------------
// ܂ȂԂ鑋
//-----------------------------------------------------------------------

class FoldableWindow
{
public:
	FoldableWindow() : original_wnd( NULL ) {}

	void Init( HWND wnd, HWND ura )
	{
		RECT pos;
		::GetWindowRect( wnd, &pos );

		// {
		original_wnd = wnd;
		ura_wnd      = ura;
		shape        = FoldedRect(pos);
		state        = TAIRA;

		::SetWindowLongPtr( ura, GWLP_USERDATA,  reinterpret_cast<LONG_PTR>(&shape) );

		// ݂̌`ۑƂ
		original_rgn = ::CreateRectRgn( 0, 0, pos.right-pos.left, pos.bottom-pos.top );
		::GetWindowRgn( original_wnd, original_rgn );

		// nő剻BB
		HRGN tmp = ::CreateRectRgn( 0, 0, 0, 0 );
		::SetWindowRgn( ura_wnd, tmp, TRUE );
		::SetWindowPos( ura_wnd, NULL,
			0, 0, ::GetSystemMetrics(SM_CXSCREEN), ::GetSystemMetrics(SM_CYSCREEN), SWP_NOZORDER|SWP_SHOWWINDOW );
	}

	~FoldableWindow()
	{
		// n̔jA`󕜋A
		if( original_wnd )
		{
			::SetWindowRgn( original_wnd, original_rgn, TRUE );
			::DestroyWindow( ura_wnd );
		}
	}

	bool mouse( const dcomp& prev_pt, const dcomp& pt )
	{
		// `ČvZ
		if( !calcShape(prev_pt, pt) )
			return false;

		// ωĂʕ\
		updateShape();
		return true;
	}

	bool covers( const dcomp& pt ) { return shape.covers(pt); }
	bool rect_covers( const dcomp& pt ) { return shape.rect_covers(pt); }
	bool get_orime( dcomp& p1, dcomp& p2 ) { return shape.get_orime(p1,p2); }
	bool rebend( const dcomp& p1, const dcomp& p2 )
	{
		if(!shape.rebend(p1,p2))
			return false;
		state=ORETERU;
		updateShape();
		return true;
	}

	bool is_taira() const
	{
		return state == TAIRA;
	}

private:
	bool calcShape( const dcomp& prev_pt, const dcomp& pt );
	void updateShape();

private:
	HWND       original_wnd, ura_wnd;
	HRGN       original_rgn;
	FoldedRect shape;

private:
	enum State { TAIRA, MEKURI, ORETERU };
	State state;
};
