#pragma once

//--------------------------
// CxgXi
//--------------------------

class TrayIconEventHandler
{
	virtual HMENU on_menu()           { return NULL; }
	virtual void  on_command( HMENU menu, UINT id ) {}
	friend class TrayIcon;
};

//--------------------------
// gCACR
//--------------------------

class TrayIcon : noncopyable
{
public:
	TrayIcon( TrayIconEventHandler* evhan, const char* dummyWndName = "TrayIcon" );
	~TrayIcon();

	void readd();
	void setIcon( HICON icn );
	void setTip( string str );

private:
	bool send_ADD();
	bool send_MODIFY();
	bool send_DELETE();
	bool send_SETVERSION();

private:
	static UINT getTaskbarCreatedMsg();
	static UINT getStdNotifyMsg();
	static const char* enrollStdHiddenWndClass();
	static LRESULT CALLBACK HiddenWndProc( HWND wnd, UINT msg, WPARAM wp, LPARAM lp );

private:
	NOTIFYICONDATA              config;
	HWND                        eventHandlerWnd;
	TrayIconEventHandler* const evhan;
};
